package com.example.marcus_sandroidexample;

import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.util.logging.Level;
import java.util.logging.Logger;


public class MainActivity extends AppCompatActivity {

    TextView time_view;
    Button start_stop;
    Button reset;

    public static final long SLEEPTIME = 10;
    boolean running;
    Thread refreshThread;
    double time;

    public void initThread() {
        refreshThread = new Thread(new Runnable() {
            public void run() {
                while (running) {
                    time = time + 0.01;
                    try {
                        Thread.sleep(SLEEPTIME);
                    } catch (InterruptedException ex) {
                        Logger.getLogger(MainActivity.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    runOnUiThread(new Runnable() {
                        public void run() {
                            time_view.setText(getString(R.string.time_string, String.format("%.2f", time)));
                        }
                    });
                }
            }
        });
        refreshThread.start();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        running = false;
        time = 0;

        start_stop = (Button) findViewById(R.id.start_stop);
        time_view = (TextView) findViewById(R.id.time_view);
        reset = (Button) findViewById(R.id.reset);

        time_view.setText(getString(R.string.time_string, String.format("%.2f", time)));

        start_stop.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                if (!running) {
                    running = true;
                    initThread();
                    start_stop.setText(R.string.stop);

                } else {
                    running = false;
                    start_stop.setText(R.string.start);
                }
            }
        });

        reset.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                time = 0;
                time_view.setText(getString(R.string.time_string, String.format("%.2f", time)));
            }
        });
    }
}
